<script>
    import { mouse_position } from "../../svelte_stores/mouse_position.js";
    import { selected_issue_timetag } from "../../svelte_stores/selected_forecast_issue_store.js";
    import BarPlot from "./BarPlot.svelte";
    import AreaPlot from "./AreaPlot.svelte";
    import LinePlot from "./LinePlot.svelte";
    export let plot_element;
    export let subplot;
    export let data;
    export let xScale;
    export let yScale;
    export let interact = true;

    // Move this code to the datastore, so that it is not unnecesarily repeated if a forecast contains multiple plot elements.
    let unique_issue_timetags;
    $: issue_timetags = data.datalist.map((a) => a.timetag_issue).sort();
    $: {
        unique_issue_timetags = [...new Set(issue_timetags)];
        if (
            !(plot_element.data.dataset in $selected_issue_timetag) &&
            unique_issue_timetags.length > 0
        ) {
            $selected_issue_timetag[plot_element.data.dataset] =
                unique_issue_timetags.at(-1);
        }
    }

    function onKeyDown(e) {
        if (!interact) {
            return;
        }
        if (
            $mouse_position.y >= yScale.range()[1] &&
            $mouse_position.y <= yScale.range()[0]
        ) {
            let index = unique_issue_timetags.indexOf(
                $selected_issue_timetag[plot_element.data.dataset],
            );
            let new_index = index;
            switch (e.keyCode) {
                case 37: // Left-arrow
                    new_index = index - 1;
                    break;
                case 39: // Right-arrow
                    new_index = index + 1;
                    break;
            }
            if (new_index < 0) {
                new_index = 0;
            }
            if (new_index > unique_issue_timetags.length - 1) {
                new_index = unique_issue_timetags.length - 1;
            }
            $selected_issue_timetag[plot_element.data.dataset] =
                unique_issue_timetags[new_index];
        }
    }
    $: selected_data = {
        datalist: data.datalist.filter(function (d) {
            return (
                d.timetag_issue ==
                $selected_issue_timetag[plot_element.data.dataset]
            );
        }),
        cadence: data.cadence,
    };
</script>

<svelte:window on:keydown={onKeyDown} />

{#if plot_element.plot_options.plot_type == "bars"}
    <BarPlot {plot_element} data={selected_data} {xScale} {yScale} />
{:else if plot_element.plot_options.plot_type == "area"}
    <AreaPlot {plot_element} {subplot} data={selected_data} {xScale} {yScale} />
{:else if plot_element.plot_options.plot_type == "line"}
    <LinePlot {plot_element} data={selected_data} {xScale} {yScale} {subplot} />
{/if}

{#each unique_issue_timetags as d}
    {#if d == $selected_issue_timetag[plot_element.data.dataset]}
        <!-- Selected prediction indicator -->
        <circle
            cx={xScale(new Date(d))}
            cy={yScale.range()[0]}
            r="4"
            fill={plot_element.plot_options.fill}
            stroke-width="2"
            stroke="black" />
        <line
            x1={xScale(new Date(d))}
            x2={xScale(new Date(d))}
            y1={yScale.range()[0]}
            y2={yScale.range()[1]}
            stroke-width="1"
            stroke={plot_element.plot_options.stroke}
            stroke-opacity="50%" />
    {:else}
        <!--  -->
        <!-- Unselected prediction indicator -->
        <circle
            cx={xScale(new Date(d))}
            cy={yScale.range()[0]}
            r="4"
            fill="white"
            fill-opacity="0%"
            stroke="black"
            stroke-width="1" />
        <!-- Larger invisible click target -->
        {#if interact}
            <circle
                cx={xScale(new Date(d))}
                cy={yScale.range()[0]}
                r="25"
                fill="none"
                fill-opacity="0%"
                stroke="none"
                stroke-width="0"
                stroke-opacity="0%"
                on:click={function () {
                    $selected_issue_timetag[plot_element.data.dataset] = d;
                }}
                on:keydown={function () {
                    $selected_issue_timetag[plot_element.data.dataset] = d;
                }} />
        {/if}
    {/if}
{/each}
